package com.duowan.texiu.data.migration.script;

import com.duowan.texiu.data.migration.model.TableInfo;
import com.duowan.texiu.data.migration.model.VideoInfoFF;
import com.duowan.texiu.data.migration.tools.*;
import org.apache.commons.lang3.StringUtils;

import java.io.IOException;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author Zhang Miaojie
 * @version v1.0
 * @date 2019/11/20
 */
public class BatchHandleVideo {


    private final static String BASE_PATH = "E:\\tmp\\test\\";

    public static void main(String[] args) throws SQLException, InterruptedException, IOException, ServiceException {
        TableInfo tableInfo = new TableInfo();
        tableInfo.setTableName("template");
        ArrayList<String> arrayList = new ArrayList<>();
        arrayList.add("url");
        arrayList.add("flag");
        tableInfo.setCols(arrayList);

        String selectSql = SqlUtil.getSelectSql(tableInfo.getTableName(), tableInfo.getCols());
        List<Map<String, Object>> maps = DBUtil.queryList(selectSql);

        for (Map<String, Object> map : maps) {
            String url = (String) map.get("url");
            String flag = (String) map.get("flag");

            if (StringUtils.isBlank(url)) {
                continue;
            }

            String inputPath = BASE_PATH + flag + ".mp4";
            FileUtil.downloadLocalDirectory(url, inputPath);

            VideoInfoFF videoInfoFF = FFmpegUtils.getVideoInfoFF(inputPath);
            String duration = videoInfoFF.getFormat().getDuration();

            String sql = String.format("update template set duration=%s where flag = \"%s\";\n", Double.valueOf(duration).intValue(), flag);
            TextUtil.saveAsFileWriter("template1", sql);
        }
    }
}
