package com.duowan.texiu.data.migration.script;

import com.alibaba.fastjson.JSON;
import com.duowan.texiu.data.migration.model.EditJsonInfo;
import com.duowan.texiu.data.migration.model.TableInfo;
import com.duowan.texiu.data.migration.model.VideoInfoFF;
import com.duowan.texiu.data.migration.tools.*;
import org.apache.commons.lang3.StringUtils;

import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author Zhang Miaojie
 * @version v1.0
 * @date 2019/11/21
 */
public class BatchHandleVideoTask {
    private final static String BASE_PATH = "E:\\tmp\\zip\\";

    public static void main(String[] args) throws SQLException, InterruptedException, IOException, ServiceException {
        TableInfo tableInfo = new TableInfo();
        tableInfo.setTableName("template");
        ArrayList<String> arrayList = new ArrayList<>();
        arrayList.add("sourceUrl");
        arrayList.add("type");
        arrayList.add("flag");
        arrayList.add("musicId");
        tableInfo.setCols(arrayList);

        String selectSql = SqlUtil.getSelectSql(tableInfo.getTableName(), tableInfo.getCols());
        List<Map<String, Object>> maps = DBUtil.queryList(selectSql);

        for (Map<String, Object> map : maps) {
            Integer type = (Integer) map.get("type");
            int size;
            String flag = (String) map.get("flag");
            if (type == 9) {
                Long musicId = (Long) map.get("musicId");
                String sql = "select cp.* from music m left join cardPoint cp on m.flag = cp.musicFlag where m.id = " + musicId;

                List<Map<String, Object>> maps1 = DBUtil.queryList(sql);
                size = maps1.size();
            } else {
                String sourceUrl = (String) map.get("sourceUrl");

                if (StringUtils.isBlank(sourceUrl)) {
                    continue;
                }
                String inputPath = BASE_PATH + flag + ".zip";

                File file = new File(inputPath);
                if (!file.exists()) {
                    FileUtil.downloadLocalDirectory(sourceUrl, inputPath);
                }
                ZipUtil.unZipFiles(new File(inputPath));
                String editJsonFilePath = BASE_PATH + flag + File.separator + "edit.json";
                String editJson = TextUtil.file2String(new File(editJsonFilePath), "UTF-8");

                EditJsonInfo editJsonInfo = JSON.parseObject(editJson, EditJsonInfo.class);
                size = editJsonInfo.getItems().size();
            }
            String sql = String.format("update template set fragment =%s where flag = \"%s\";\n", size, flag);
            TextUtil.saveAsFileWriter("template2", sql);
        }
    }
}
