package com.duowan.texiu.data.migration.tools;

import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author Zhang Miaojie
 * @version v1.0
 * @date 2019/10/10
 */
public class DBUtil {

	// private static final String URL =
	// "jdbc:mysql://47.97.96.155:3306/texiu_home_prod?allowMultiQueries=true&useUnicode=true&characterEncoding=UTF-8&useSSL=false";
	// 特炫 测试环境
	// private static final String URL =
	// "jdbc:mysql://61.160.36.19:3306/texiu_home?allowMultiQueries=true&useUnicode=true&characterEncoding=UTF-8&useSSL=false";

	// 特炫 阿里云环境
	// private static final String URL =
	// "jdbc:mysql://rm-wz9aky1r32bcp7c.mysql.rds.aliyuncs.com:3306?allowMultiQueries=true&useUnicode=true&characterEncoding=UTF-8&useSSL=false";

	private static Connection conn = null;

	// 静态代码块（将加载驱动、连接数据库放入静态块中）
	static {
		try {
			// 1.加载驱动程序
			Class.forName("com.mysql.cj.jdbc.Driver");
			// 2.获得数据库的连接
			conn = DriverManager.getConnection(Constants.DB_CONNECTION_URL, Constants.DB_USER_NAME,
					Constants.DB_USER_PASSWORD);
		} catch (ClassNotFoundException | SQLException e) {
			e.printStackTrace();
		}
	}

	public static List<Map<String, Object>> queryList(String selectSql) throws SQLException {
		Statement statement = conn.createStatement();
		ResultSet resultSet = statement.executeQuery(selectSql);
		List<Map<String, Object>> list = new ArrayList<>();

		// 获得结果集结构信息,元数据
		ResultSetMetaData md = resultSet.getMetaData();

		// 获得列数
		int columnCount = md.getColumnCount();
		while (resultSet.next()) {
			Map<String, Object> rowData = new HashMap<>();
			for (int i = 1; i <= columnCount; i++) {
				rowData.put(md.getColumnName(i), resultSet.getObject(i));
			}
			list.add(rowData);
		}
		return list;
	}

	public static void update(String executeSql) throws SQLException {
		Statement statement = conn.createStatement();
		statement.executeUpdate(executeSql);
	}

}
