package com.duowan.texiu.data.migration.tools;

import java.io.File;
import java.io.IOException;

import com.duowan.texiu.data.migration.model.VideoInfoFF;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSON;
import com.ojia.base.util.CommandLineTools;

/**
 * @author Zhang Miaojie
 * @version v1.0
 * @date 2019/7/30
 */
public class FFmpegUtils {
	private static final Logger log = LoggerFactory.getLogger(FFmpegUtils.class);

	public static void main(String[] args) throws InterruptedException, IOException, ServiceException {
		// getVideoInfoFF("F:\\resources\\test\\e3d741da868a5128a42d7e03cb56e3ba_len39009900.mp4");
		screenshot("F:\\resources\\test\\e3d741da868a5128a42d7e03cb56e3ba_len39009900.mp4",
				"F:\\resources\\test\\output\\123.jpg", 19);
	}

	/**
	 * 获取视频信息详情
	 *
	 * @param inputFile
	 * @return
	 * @throws InterruptedException
	 * @throws ServiceException
	 * @throws IOException
	 */
	public static VideoInfoFF getVideoInfoFF(String inputFile) throws InterruptedException, ServiceException, IOException {
		if (!checkfile(inputFile)) {
			throw new ServiceException(inputFile + " is not file");
		}
		String command = String.format(VideoConstant.Command.GET_VIDEO_INFO, inputFile);
		String s = CommandLineTools.execCommand(command);
		VideoInfoFF VideoInfoFF = JSON.parseObject(s, VideoInfoFF.class);
		System.out.println(s);
		return VideoInfoFF;
	}

	/**
	 * 获取视频截图
	 *
	 * @param inputFile
	 * @param outputFile
	 * @param seconds
	 * @return
	 * @throws InterruptedException
	 * @throws IOException
	 * @throws ServiceException
	 */
	public static String screenshot(String inputFile, String outputFile, int seconds)
			throws InterruptedException, IOException, ServiceException {
		return screenshot(inputFile, outputFile, true, 0, 0, seconds);
	}

	/**
	 * 视频截图
	 *
	 * @param inputFile
	 * @param outputFile
	 * @param isOriginalSize
	 * @param width
	 * @param height
	 * @param seconds
	 * @return
	 * @throws InterruptedException
	 * @throws ServiceException
	 * @throws IOException
	 */
	public static String screenshot(String inputFile, String outputFile, boolean isOriginalSize, int width, int height,
			double seconds) throws InterruptedException, ServiceException, IOException {
		VideoInfoFF VideoInfoFF = getVideoInfoFF(inputFile);
		if (isOriginalSize) {
			for (VideoInfoFF.StreamsBean streamsBean : VideoInfoFF.getStreams()) {
				if (streamsBean.getCodec_type().equals("video")) {
					height = streamsBean.getCoded_height();
					width = streamsBean.getCoded_width();
					break;
				}
			}
		}
		if (width <= 0 || height <= 0) {
			throw new ServiceException("图片的高度或宽度不能小于0！");
		}
		Double duration = Double.valueOf(VideoInfoFF.getFormat().getDuration());
		if (seconds > duration) {
			throw new ServiceException("截取的时间不能大于视频播放长度！");
		}
		String command = String.format(VideoConstant.Command.SCREENSHOT, inputFile, seconds, width, height, outputFile);
		return CommandLineTools.execCommand(command);
	}

	private static boolean checkfile(String path) {
		File file = new File(path);
		return file.isFile();
	}

}
