package com.duowan.texiu.data.migration.tools;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * @author Zhang Miaojie
 * @version v1.0
 * @date 2019/10/12
 */
public class HttpClient {

	private final static String UPLOAD_FILE_API = "http://localhost:8888/proxy/api/uploadFile";
	private final static Integer RESPONSE_OK = 200;
	private final static String ACCESS_TOKEN = "zwaXnoi5OM-s";


	/**
	 * 上传文件
	 *
	 * @param localFilePath
	 * @return
	 * @throws ClientProtocolException
	 * @throws IOException
	 */
	public static String uploadFile(String localFilePath, int isTemplate) throws ClientProtocolException, IOException {
		CloseableHttpClient httpClient = HttpClientBuilder.create().build();
		RequestConfig requestConfig = RequestConfig.custom().setConnectTimeout(200000).setSocketTimeout(200000)
				.build();

		CloseableHttpResponse httpResponse = null;
		String result = null;
		try {
			HttpPost httpPost = new HttpPost(UPLOAD_FILE_API);
			httpPost.setConfig(requestConfig);
			MultipartEntityBuilder multipartEntityBuilder = MultipartEntityBuilder.create();

			File file = new File(localFilePath);

			multipartEntityBuilder.addBinaryBody("file", file);
			multipartEntityBuilder.addTextBody("isTemplate", String.valueOf(isTemplate));
			multipartEntityBuilder.addTextBody("token", ACCESS_TOKEN);
			HttpEntity httpEntity = multipartEntityBuilder.build();
			httpPost.setEntity(httpEntity);

			httpResponse = httpClient.execute(httpPost);
			HttpEntity responseEntity = httpResponse.getEntity();
			int statusCode = httpResponse.getStatusLine().getStatusCode();
			if (statusCode == RESPONSE_OK) {
				BufferedReader reader = new BufferedReader(new InputStreamReader(responseEntity.getContent()));
				StringBuffer buffer = new StringBuffer();
				String str = "";
				while (StringUtils.isNotBlank(str = reader.readLine())) {
					buffer.append(str);
				}
				result = buffer.toString();
			}
		} finally {
			httpClient.close();
			if (httpResponse != null) {
				httpResponse.close();
			}
		}
		return result;
	}

	public static void main(String[] args) throws IOException {
		String s = uploadFile("F:\\resources\\test\\dw_video\\20190812102406_七夕.jpeg", 0);
		System.out.println(s);
		UploadApiResult uploadApiResult = JSONObject.parseObject(s, UploadApiResult.class);
		System.out.println(uploadApiResult.getData());

	}
}
