package com.duowan.texiu.data.migration.tools;

import java.io.IOException;

import com.duowan.texiu.data.migration.model.VideoInfo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSONObject;
import com.ojia.base.exception.HttpClientException;
import com.ojia.base.http.HttpHelper;
import com.ojia.base.http.HttpMethod;

/**
 * http工具类
 *
 * @Author: linjiazhi
 * @Date: 2019/6/28
 */
public class HttpUtils {

	public static final Logger log = LoggerFactory.getLogger(HttpUtils.class);

	/**
	 * 获取多玩视频信息
	 *
	 * @param dwVid
	 *            多玩视频id
	 */
	public static VideoInfo getDwVideoInfo(long dwVid)
			throws  HttpClientException {
		String url = "http://playapi.v.duowan.com/?r=play/video&partner=dw&vid=" + dwVid;

		byte[] rsp = null;

		for (int i = 0; i < 2; i++) {
			try {
				rsp = HttpHelper.http(url, HttpMethod.GET, null, null);
				break;
			} catch (IOException e) {
				// log.error("", e);
			}
		}
		if (null == rsp) {
			log.error(String.format("http get video info error url=%s", url));
			throw new RuntimeException("http get video info error url");
		}
		String repStr = new String(rsp);
		VideoInfo videoInfo = JSONObject.parseObject(repStr, VideoInfo.class);

		int code = videoInfo.getCode();
		String msg = videoInfo.getMessage();
		if (0 == code) {
			log.error(String.format("http get video info error msg=%s,vid=%d", msg, dwVid));
			if ("deleted".equals(msg)) {
				throw new RuntimeException("http get video info error url");
			} else {
				throw new RuntimeException("http get video info error url");
			}
		}
		return videoInfo;
	}

}
