package com.duowan.texiu.data.migration.tools;

import java.io.*;

/**
 * @author Zhang Miaojie
 * @version v1.0
 * @date 2019/11/11
 */
public class TextUtil {

	public static void saveAsFileWriter(String tableName, String content) {
		FileWriter fwriter = null;
		try {
			// true表示不覆盖原来的内容，而是加到文件的后面。若要覆盖原来的内容，直接省略这个参数就好
			File file = new File(String.format(Constants.SQL_FILE_EXPORT_PATH, tableName));
			if (!file.exists()) {
				file.createNewFile();
			}
			fwriter = new FileWriter(String.format(Constants.SQL_FILE_EXPORT_PATH, tableName), true);
			fwriter.write(content);
		} catch (IOException ex) {
			ex.printStackTrace();
		} finally {
			try {
				fwriter.flush();
				fwriter.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}

	public static String formatText(String text) {
		String arg1 = Character.toString('\"');
		String arg2 = "\\\\" + '"';
		String ret = text.replaceAll(arg1, arg2);

		String arg3 = Character.toString('\'');
		String arg4 = "\\\\'";
		return ret.replaceAll(arg3, arg4);
	}

	/**
	 * 文本文件转换为指定编码的字符串
	 *
	 * @param file
	 *            文本文件
	 * @param encoding
	 *            编码类型
	 * @return 转换后的字符串
	 * @throws IOException
	 */
	public static String file2String(File file, String encoding) {
		InputStreamReader reader = null;
		StringWriter writer = new StringWriter();
		try {
			if (encoding == null || "".equals(encoding.trim())) {
				reader = new InputStreamReader(new FileInputStream(file), encoding);
			} else {
				reader = new InputStreamReader(new FileInputStream(file));
			}
			// 将输入流写入输出流
			char[] buffer = new char[1024];
			int n = 0;
			while (-1 != (n = reader.read(buffer))) {
				writer.write(buffer, 0, n);
			}
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		} finally {
			if (reader != null)
				try {
					reader.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
		}
		// 返回转换结果
        return writer.toString();
	}

}
