//package com.duowan.texiu.data.migration;
//
//import java.util.Objects;
//import java.util.concurrent.TimeUnit;
//
///**
// * @author Zhang Miaojie
// * @version v1.0
// * @date 2019/11/4
// */
//public class ProLock {
//
//	public boolean lock(long acquireTimeout, TimeUnit timeUnit) throws InterruptedException {
//		acquireTimeout = timeUnit.toMillis(acquireTimeout);
//		long acquireTime = acquireTimeout + System.currentTimeMillis();
//		// 使用J.U.C的ReentrantLock
//		threadLock.tryLock(acquireTimeout, timeUnit);
//		try {
//			// 循环尝试
//			while (true) {
//				// 调用tryLock
//				boolean hasLock = tryLock();
//				if (hasLock) {
//					// 获取锁成功
//					return true;
//				} else if (acquireTime < System.currentTimeMillis()) {
//					break;
//				}
//				Thread.sleep(sleepTime);
//			}
//		} finally {
//			if (threadLock.isHeldByCurrentThread()) {
//				threadLock.unlock();
//			}
//		}
//		return false;
//	}
//
//	public boolean tryLock() {
//		long timeout = 6000L;
//		String mutex = "redisKey";
//		long currentTime = System.currentTimeMillis();
//		String expires = String.valueOf(timeout + currentTime);
//		// 设置互斥量
//		if (redisHelper.setNx(mutex, expires) > 0) {
//			// 获取锁，设置超时时间
//			setLockStatus(expires);
//			return true;
//		} else {
//			String currentLockTime = redisHelper.get(mutex);
//			// 检查锁是否超时
//			if (Objects.nonNull(currentLockTime) && Long.parseLong(currentLockTime) < currentTime) {
//				// 获取旧的锁时间并设置互斥量
//				String oldLockTime = redisHelper.getSet(mutex, expires);
//				// 旧值与当前时间比较
//				if (Objects.nonNull(oldLockTime) && Objects.equals(oldLockTime, currentLockTime)) {
//					// 获取锁，设置超时时间
//					setLockStatus(expires);
//					return true;
//				}
//			}
//			return false;
//		}
//	}
//
//    public boolean unlock() {
//        //只有锁的持有线程才能解锁
//        if (lockHolder == Thread.currentThread()) {
//            //判断锁是否超时，没有超时才将互斥量删除
//            if (lockExpiresTime > System.currentTimeMillis()) {
//                redisHelper.del(mutex);
//                logger.info("删除互斥量[{}]", mutex);
//            }
//            lockHolder = null;
//            logger.info("释放[{}]锁成功", mutex);
//            return true;
//        } else {
//            throw new IllegalMonitorStateException("没有获取到锁的线程无法执行解锁操作");
//        }
//    }
//}
